package demo;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import javax.swing.tree.*;

import com.japisoft.fastparser.*;
import com.japisoft.fastparser.document.*;

/**
 * Demonstration of parsing with a Jtree 
 * </p>
 * @author (c) 2002-2003 JAPISOFT
 * @version 1.0
 */
public class Demo extends JFrame implements ActionListener {

    private JTree tree;

    public Demo() {
	super();   
	JButton b = new JButton( "Click to Select an XML file (use /xml-data)" );
	b.addActionListener( this );
	getContentPane().add( BorderLayout.NORTH, b );
	getContentPane().add( BorderLayout.CENTER, new JScrollPane( tree = new JTree() ) );
	setSize( 300, 400 );
	setTitle( "Swing demo" );
    }

    public void actionPerformed( ActionEvent e ) {
	// XML Selection
	JFileChooser chooser = new JFileChooser();
	int returnVal = chooser.showOpenDialog( this );
	if ( returnVal == JFileChooser.APPROVE_OPTION ) {
            File f = chooser.getSelectedFile();

	    try {

		Parser p = new Parser();
		p.setNodeFactory( new SwingNodeFactory() );
		p.setInputStream( new FileInputStream( f ) );
		p.parse();
		Document d = p.getDocument();
		tree.setModel( new DefaultTreeModel( (TreeNode)d.getRoot() ) );

	    } catch( Throwable th ) {
		th.printStackTrace();
		JOptionPane.showMessageDialog( null, 
					       "Error", 
					       th.getMessage(), 
					       JOptionPane.ERROR_MESSAGE );
	    }
	}
    }

    public static void main( String[] a ) {
	Demo d = new Demo();
	d.setVisible( true );
    }

}

// Demo ends here
