package demo;

import com.japisoft.fastparser.document.*;
import com.japisoft.fastparser.node.*;

/**
 * Node factory for JTREE node
 * @author (c) 2002-2003 JAPISOFT
 * @version 1.0
 * @see NodeFactory
 */
public class SwingNodeFactory implements NodeFactory {
    public SwingNodeFactory() {
	super();   
    }

    private static NodeFactory instance;

    /** @return a single instance of the node factory */
    public static NodeFactory getFactory() { 
	if ( instance == null )
	    instance = new SwingNodeFactory();
	return instance; 
    }

    /** @return a text node */
    public MutableNode getTextNode( String text ) {
	SimpleNode node = new SwingNode( SimpleNode.TEXT_NODE, text );
	node.setDocument( doc );
	return node;
    }

    /** @return a tag node */
    public MutableNode getTagNode( String tag ) {
	SimpleNode node = new SwingNode( SimpleNode.TAG_NODE, tag );
	node.setDocument( doc );
	return node;
    }

    /** @return a comment node */
    public MutableNode getCommentNode( String comment ) {
	SimpleNode node = new SwingNode( SimpleNode.COMMENT_NODE, comment );
	node.setDocument( doc );
	return node;
    }

    /** Reference document */
    public void setRefDocument( Document doc ) {
	this.doc = doc;
    }

    private Document doc;

}

// SwingNodeFactory ends here
